<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
  	extension-element-prefixes="redirect">

	<xsl:import href="xradar://stylesheets/radar/statics/report/framework/master-report-presentation.xsl"/>


<xsl:template name="methods-snapshot">
	<xsl:param name="packages-element"/>


			<redirect:write file="{$docs-home}/analysis/class-methods-by-package.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by method names'"/>
					<xsl:with-param name="table-id" select="'methods-by-package'"/>
		    	</xsl:call-template>
	   		</redirect:write>

	   		<redirect:write file="{$docs-home}/analysis/class-methods-by-class.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by method names'"/>
					<xsl:with-param name="table-id" select="'methods-by-class'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/analysis/class-methods-by-name.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by method names'"/>
					<xsl:with-param name="table-id" select="'methods-by-name'"/>
		    	</xsl:call-template>
	   		</redirect:write>

	   		<redirect:write file="{$docs-home}/analysis/class-methods-by-ccn.html">
				<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by method complexity'"/>
					<xsl:with-param name="table-id" select="'methods-by-ccn'"/>
				</xsl:call-template>
			</redirect:write>

			<redirect:write file="{$docs-home}/analysis/class-methods-by-ncss.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by method source statements'"/>
					<xsl:with-param name="table-id" select="'methods-by-ncss'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/analysis/class-methods-by-import-couplings.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by import couplings'"/>
					<xsl:with-param name="table-id" select="'methods-by-import-couplings'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/analysis/class-methods-by-export-couplings.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by export couplings'"/>
					<xsl:with-param name="table-id" select="'methods-by-export-couplings'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/analysis/class-methods-by-tsc.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by tsc'"/>
					<xsl:with-param name="table-id" select="'methods-by-tsc'"/>
		    	</xsl:call-template>
	   		</redirect:write>

			<redirect:write file="{$docs-home}/analysis/class-methods-by-test-reference.html">
		    	<xsl:call-template name="class-methods">
					<xsl:with-param name="packages-element" select="$packages-element"/>
					<xsl:with-param name="table-type" select="'sorted by test reference'"/>
					<xsl:with-param name="table-id" select="'methods-by-test-reference'"/>
		    	</xsl:call-template>
	   		</redirect:write>

</xsl:template>

<xsl:template name="class-methods">
	<xsl:param name="packages-element"/>
	<xsl:param name="table-type"/>
	<xsl:param name="table-id"/>

   <html>
      <head>
          <link rel="stylesheet" type="text/css" href="../stylesheet.css"/>
      </head>
      <body>
        <xsl:call-template name="page-header">
  	  		<xsl:with-param name="main-menu-page-name" select="'analysis'"/>
  	  		<xsl:with-param name="page-name" select="'method analysis'"/>
  	  		<xsl:with-param name="root-element" select=".."/>
  	  		<xsl:with-param name="path-to-root" select="'../'"/>
  	    </xsl:call-template>
  	 <br/>
  	 Press header links to alter sort criteria.
  	 <br/>
  	 <table class="details" width="100%">
  	 	<tr>
			<th><a href="class-methods-by-package.html">Package</a></th>
			<th><a href="class-methods-by-class.html">Class</a></th>
			  <th><a href="class-methods-by-name.html">Method</a></th>
			  <th><a href="class-methods-by-ncss.html">Source statements</a></th>
			  <th><a href="class-methods-by-ccn.html">Cyclometic complexity</a></th>
			  <th><a href="class-methods-by-import-couplings.html">Import Couplings</a></th>
			  <th><a href="class-methods-by-export-couplings.html">Export Couplings</a></th>
			  <th><a href="class-methods-by-tsc.html">Statement Test Coverage</a></th>
			  <th><a href="class-methods-by-test-reference.html">Test References</a></th>
		</tr>
  	 	<xsl:choose>
	  	 	<xsl:when test="$table-id='methods-by-package'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="../../../../@name"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
	  	 	<xsl:when test="$table-id='methods-by-class'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="substring-after(normalize-space(../../node()), concat(../../../../@name,'.'))"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
	  	 	<xsl:when test="$table-id='methods-by-name'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="substring-after(name, concat(normalize-space(../../node()),'.'))"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
  	 		<xsl:when test="$table-id='methods-by-ncss'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="ncss" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
  	 		<xsl:when test="$table-id='methods-by-ccn'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="ccn" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='methods-by-import-couplings'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="coupling-metrics/import-coupling" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='methods-by-export-couplings'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="coupling-metrics/export-coupling" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>

			<xsl:when test="$table-id='methods-by-tsc'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="sum(test-metrics/line-coverage)" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
			<xsl:when test="$table-id='methods-by-test-reference'">
	  	 		<xsl:for-each select="$packages-element/Package/child::node()[name() = 'AbstractClasses' or name() = 'ConcreteClasses']/Class/functions/function">
		  	 		<xsl:sort select="count(test-coupling/export)" data-type="number" order="descending"/>
		  	 		<xsl:apply-templates select="current()" mode="standard-class-method-row"/>
		  	 	</xsl:for-each>
  	 		</xsl:when>
  	 	</xsl:choose>
  	 </table>

  	</body>
  </html>
</xsl:template>

</xsl:stylesheet>
