<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xalan="http://xml.apache.org/xalan"
	xmlns:lxslt="http://xml.apache.org/xslt"
    	xmlns:redirect="http://xml.apache.org/xalan/redirect"
    	extension-element-prefixes="redirect">
    
	<xsl:import href="master-report-detail-scorecard-table.xsl"/>
	<xsl:include href="xradar://stylesheets/util/api/filenameToUnix.xsl"/>

<xsl:template match="IntegratedAnalysis" mode="scorecard-overview">

	<xsl:variable name="packages-element" select="Packages"/>

   	<html>
      <head>
         <link rel="stylesheet" type="text/css" href="stylesheet.css"/>
      </head>
      <body>

         <xsl:call-template name="page-header">
  	  	   <xsl:with-param name="main-menu-page-name" select="'scorecard'"/>
  	  	   <xsl:with-param name="page-name" select="'overview'"/>
  	  	   <xsl:with-param name="root-element" select="current()"/>
  	     </xsl:call-template>

		<h3>Scorecard (<xsl:value-of select="@system"/>)</h3>
		<!--p>
		    This page gives a scorecard of this system' quality. The quality measure is defined for this specific system. Every metric
            has a value in the range from 0 to 1. 0 is the worst possible score, while 1 is the best. The formula for how the metric has been
            calculated is also shown.
            <br/>
            Press the subsystem graph to see scorecard details on the specific subsystem.
        </p-->
          <table width="100%" class="scorecard">
            <tr>
                <td style="background-color: white; align: middle; vertical-align: top">
					<div align="center">
						  <embed width="450" height="450" src="img/spider-graph-system.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
					</div>
                </td>
                <td style="background-color: white; align: middle; vertical-align: top">
                	 <xsl:variable name="system_quality_report_filename"> 
			        	<xsl:call-template name="filename2unix">
				        	<xsl:with-param 	name="url" 
				        						select="concat($docs-home,'/xml/reports/system_quality_report.xml')"/>
				        </xsl:call-template> 
			        </xsl:variable>
					<xsl:call-template name="scorecard-table">
						<xsl:with-param name="system-quality-report"
										select="document(concat('file://',$system_quality_report_filename))"/>
					</xsl:call-template>
                </td>
            </tr>
			<tr>
                <td style="background-color: white; align: middle; vertical-align: top">
					<div align="center">
					  <embed width="450" height="450" src="img/subsystem-quality-graph.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
					</div>
                </td>
                <td style="background-color: white; align: middle; vertical-align: top">
					<div align="center">
						  <embed width="450" height="450" src="img/subsystem-quality-histogram.svg" name="svgmap" pluginspage="http://www.adobe.com/svg/viewer/install/" type="image/svg+xml"></embed>
					</div>
                </td>
            </tr>
        </table>
      </body>
   </html>
</xsl:template>


</xsl:stylesheet>
